import {
  ClassType,
} from '@overflow/commons/core/type';

import { Assert } from '@overflow/commons/core/util';

import {
  InstanceDefinitionRegistry, InstanceNameGenerator,
  InstanceDefinition,
} from '@overflow/commons/di/factory';


export class InstanceDefinitionReader {
  private instanceDefinitionRegistry: InstanceDefinitionRegistry;
  private instanceNameGenerator: InstanceNameGenerator;

  public constructor(registry: InstanceDefinitionRegistry) {
    Assert.notNull(registry, 'InstanceDefinitionRegistry must not be null');
    this.instanceDefinitionRegistry = registry;
  }

  public register(...injectables: ClassType[]): void {
    injectables.forEach(injectable => {
      this.registerInstance(injectable);
    });
  }

  public registerInstance(injectable: ClassType): void {
    let instanceDefinition: InstanceDefinition = new InstanceDefinition(injectable);
  }
}
